VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBrowse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const BIF_RETURNONLYFSDIRS = 1
Private Const BIF_DONTGOBELOWDOMAIN = 2
Private Const BIF_BROWSEFORCOMPUTER = &H1000

Private Const MAX_PATH = 260

Private Type BrowseInfo
    hwndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lParam As Long
    iImage As Long
End Type

Private m_Title As String
Private m_Folder As String
Private m_Parent As Long

Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long

Public Sub Browse()
    Dim lpIDList As Long
    Dim szTitle As String
    Dim tBrowseInfo As BrowseInfo
    
    szTitle = m_Title

    With tBrowseInfo
        .hwndOwner = m_Parent
        .lpszTitle = lstrcat(szTitle, "")
        .ulFlags = BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN
        
    End With
    lpIDList = SHBrowseForFolder(tBrowseInfo)

    If (lpIDList) Then
        m_Folder = Space(MAX_PATH)
        SHGetPathFromIDList lpIDList, m_Folder
        m_Folder = Left(m_Folder, InStr(m_Folder, vbNullChar) - 1)
    End If

End Sub

Public Property Let Parent(lNewValue As Long)
    m_Parent = lNewValue
End Property

Public Property Get Parent() As Long
    Parent = m_Parent
End Property

Public Property Let Title(sNewValue As String)
    m_Title = sNewValue
End Property

Public Property Get Title() As String
    Title = m_Title
End Property

Public Property Get Folder() As String
    Folder = m_Folder
End Property
